/** Rill v0.0.193 https://www.npmjs.com/package/rill License: MIT*/
var Request, getUrl, httpReg, parseDates, parseURL;

parseURL = require("urllite");

parseDates = require("./util/parseDates");

httpReg = /^https?:\/\//i;

getUrl = function(req) {
  return parseURL(httpReg.test(req.url) ? req.url : (req.socket.encrypted ? "https" : "http") + "://" + req.headers.host + req.url);
};

Request = (function() {
  function Request(req) {
    var err, ref, ref1, ref2, ref3, ref4;
    if (req == null) {
      req = {};
    }
    if (!(this instanceof Request)) {
      return new Request();
    }
    this.originalReq = req;
    this.url = getUrl(req);
    this.headers = (ref = req.headers) != null ? ref : {};
    this.method = (ref1 = req.method) != null ? ref1 : "GET";
    this.subdomains = (ref2 = this.url.host) != null ? ref2.split('.').reverse().slice(2) : void 0;
    this.ip = ((ref3 = (ref4 = this.headers['x-forwarded-for']) != null ? ref4.split(',')[0] : void 0) != null ? ref3 : req.connection.remoteAddress);
    try {
      this.query = JSON.parse(this.url.search.slice(1), parseDates);
    } catch (_error) {
      err = _error;
      this.query = {};
    }
  }

  return Request;

})();

module.exports = Request;
