/** Rill v0.0.193 https://www.npmjs.com/package/rill License: MIT*/
var noop;

noop = function*() {
  return;
};


/*
 * Compose `middleware` returning
 * a fully valid middleware comprised
 * of all those which are passed.
#
 * @param {Array} middleware
 * @return {Function}
 * @api public
 */

module.exports = function(middleware) {
  return function*(req, res, next) {
    var context, len;
    context = {};
    if (next == null) {
      next = noop;
    }
    len = middleware.length;
    while (i -= 1) {
      next = middleware[i].call(context, req, res, next);
    }
    return (yield next);
  };
};
