/** Rill v0.0.193 https://www.npmjs.com/package/rill License: MIT*/
var byteLength, empty, isType;

isType = require("./isType");

byteLength = require("./byteLength");

empty = {
  204: true,
  205: true,
  304: true
};

module.exports = function*(req, res, next) {
  var base, base1, base2, base3, base4, nRes;
  (yield next);
  nRes = res._node;
  if (nRes.headersSent) {
    return;
  }
  if (empty[res.status]) {
    res.headers["Content-Type"] = void 0;
    res.body = null;
  } else if (isType.String(res.body)) {
    if ((base = res.headers)["Content-Type"] == null) {
      base["Content-Type"] = "text/" + (/^\s*</.test(res.body) ? "html" : "plain");
    }
  } else if (isType.Object(res.body)) {
    if ((base1 = res.headers)["Content-Type"] == null) {
      base1["Content-Type"] = "application/json";
    }
    res.body = JSON.stringify(res.body);
  } else {
    if ((base2 = res.headers)["Content-Type"] == null) {
      base2["Content-Type"] = "application/octet-stream";
    }
    if (res.body.length) {
      if ((base3 = res.headers)["Content-Length"] == null) {
        base3["Content-Length"] = res.body.length;
      }
    }
    if (isType.Stream(res.body)) {
      return res.body.pipe(nRes);
    }
  }
  if ((base4 = res.headers)["Content-Length"] == null) {
    base4["Content-Length"] = byteLength(res.body);
  }
  nRes.writeHead(res.status, res.headers);
  return nRes.end("HEAD" !== req.method ? res.body : void 0);
};
