co        = require("co")
pathToReg = require("path-to-regexp")
compose   = require("./util/compose")
parseDates = require("./util/parseDates")
Request   = require("./request")
Response  = require("./response")

if process.browser
	hijack = require("./hijackBrowser")
else
	http = require("http")
	serverResponse = require("./util/serverResponse")


class Application
	constructor: ->
		return new Application() unless this instanceof Application
		@middleware = []

	listen: ->
		if process.browser
			hijack.onChange(@callback())
			hijack.listen()
		else
			server = http.createServer(@callback())
			server.listen.apply(server, arguments)

	callback: ->
		fn = co.wrap(compose((
			if process.browser then []
			else [serverResponse]
		).concat(@middleware)))
		(req, res)-> fn(new Request(req), new Response(res))

	use: (middlewares...)->
		@middleware = @middleware.concat(middlewares)

	for method in ["options", "head", "get", "put", "post", "delete"]
		@::[method] = do -> (path, middlewares...)->
			keys = []
			path = pathToReg(path, keys)
			middlewares = compose(middlewares)

			@use((req, res, next)->
				return unless req.method is method and match = req.pathname.match(path.regex)
				req.params = {}
				req.params[name] = match[i + 1] for { name }, i in keys
				yield middlewares.call(@, req, res)
			)


module.exports = Application
